diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/CMakeLists.txt ns-3.36/src/lte/CMakeLists.txt
--- ns-3.35/src/lte/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/CMakeLists.txt	2022-04-30 18:23:57.890733700 -0700
@@ -0,0 +1,363 @@
+set(emu_sources)
+set(emu_headers)
+set(emu_features)
+set(emu_libraries)
+if(${ENABLE_EMU})
+  set(emu_sources
+      helper/emu-epc-helper.cc
+  )
+  set(emu_headers
+      helper/emu-epc-helper.h
+  )
+  set(emu_features
+      EmuFdNetDevice
+  )
+  set(emu_libraries
+      ${libfd-net-device}
+  )
+endif()
+
+set(source_files
+    ${emu_sources}
+    helper/cc-helper.cc
+    helper/epc-helper.cc
+    helper/lte-global-pathloss-database.cc
+    helper/lte-helper.cc
+    helper/lte-hex-grid-enb-topology-helper.cc
+    helper/lte-stats-calculator.cc
+    helper/mac-stats-calculator.cc
+    helper/no-backhaul-epc-helper.cc
+    helper/phy-rx-stats-calculator.cc
+    helper/phy-stats-calculator.cc
+    helper/phy-tx-stats-calculator.cc
+    helper/point-to-point-epc-helper.cc
+    helper/radio-bearer-stats-calculator.cc
+    helper/radio-bearer-stats-connector.cc
+    helper/radio-environment-map-helper.cc
+    model/a2-a4-rsrq-handover-algorithm.cc
+    model/a3-rsrp-handover-algorithm.cc
+    model/component-carrier-enb.cc
+    model/component-carrier-ue.cc
+    model/component-carrier.cc
+    model/cqa-ff-mac-scheduler.cc
+    model/epc-enb-application.cc
+    model/epc-enb-s1-sap.cc
+    model/epc-gtpc-header.cc
+    model/epc-gtpu-header.cc
+    model/epc-mme-application.cc
+    model/epc-pgw-application.cc
+    model/epc-s11-sap.cc
+    model/epc-s1ap-sap.cc
+    model/epc-sgw-application.cc
+    model/epc-tft-classifier.cc
+    model/epc-tft.cc
+    model/epc-ue-nas.cc
+    model/epc-x2-header.cc
+    model/epc-x2-sap.cc
+    model/epc-x2.cc
+    model/eps-bearer-tag.cc
+    model/eps-bearer.cc
+    model/fdbet-ff-mac-scheduler.cc
+    model/fdmt-ff-mac-scheduler.cc
+    model/fdtbfq-ff-mac-scheduler.cc
+    model/ff-mac-common.cc
+    model/ff-mac-csched-sap.cc
+    model/ff-mac-sched-sap.cc
+    model/ff-mac-scheduler.cc
+    model/lte-amc.cc
+    model/lte-anr-sap.cc
+    model/lte-anr.cc
+    model/lte-as-sap.cc
+    model/lte-asn1-header.cc
+    model/lte-ccm-mac-sap.cc
+    model/lte-ccm-rrc-sap.cc
+    model/lte-chunk-processor.cc
+    model/lte-common.cc
+    model/lte-control-messages.cc
+    model/lte-enb-cmac-sap.cc
+    model/lte-enb-component-carrier-manager.cc
+    model/lte-enb-cphy-sap.cc
+    model/lte-enb-mac.cc
+    model/lte-enb-net-device.cc
+    model/lte-enb-phy-sap.cc
+    model/lte-enb-phy.cc
+    model/lte-enb-rrc.cc
+    model/lte-ffr-algorithm.cc
+    model/lte-ffr-distributed-algorithm.cc
+    model/lte-ffr-enhanced-algorithm.cc
+    model/lte-ffr-rrc-sap.cc
+    model/lte-ffr-sap.cc
+    model/lte-ffr-soft-algorithm.cc
+    model/lte-fr-hard-algorithm.cc
+    model/lte-fr-no-op-algorithm.cc
+    model/lte-fr-soft-algorithm.cc
+    model/lte-fr-strict-algorithm.cc
+    model/lte-handover-algorithm.cc
+    model/lte-handover-management-sap.cc
+    model/lte-harq-phy.cc
+    model/lte-interference.cc
+    model/lte-mac-sap.cc
+    model/lte-mi-error-model.cc
+    model/lte-net-device.cc
+    model/lte-pdcp-header.cc
+    model/lte-pdcp-sap.cc
+    model/lte-pdcp-tag.cc
+    model/lte-pdcp.cc
+    model/lte-phy-tag.cc
+    model/lte-phy.cc
+    model/lte-radio-bearer-info.cc
+    model/lte-radio-bearer-tag.cc
+    model/lte-rlc-am-header.cc
+    model/lte-rlc-am.cc
+    model/lte-rlc-header.cc
+    model/lte-rlc-sap.cc
+    model/lte-rlc-sdu-status-tag.cc
+    model/lte-rlc-sequence-number.cc
+    model/lte-rlc-tag.cc
+    model/lte-rlc-tm.cc
+    model/lte-rlc-um.cc
+    model/lte-rlc.cc
+    model/lte-rrc-header.cc
+    model/lte-rrc-protocol-ideal.cc
+    model/lte-rrc-protocol-real.cc
+    model/lte-rrc-sap.cc
+    model/lte-spectrum-phy.cc
+    model/lte-spectrum-signal-parameters.cc
+    model/lte-spectrum-value-helper.cc
+    model/lte-ue-ccm-rrc-sap.cc
+    model/lte-ue-cmac-sap.cc
+    model/lte-ue-component-carrier-manager.cc
+    model/lte-ue-cphy-sap.cc
+    model/lte-ue-mac.cc
+    model/lte-ue-net-device.cc
+    model/lte-ue-phy-sap.cc
+    model/lte-ue-phy.cc
+    model/lte-ue-power-control.cc
+    model/lte-ue-rrc.cc
+    model/lte-vendor-specific-parameters.cc
+    model/no-op-component-carrier-manager.cc
+    model/no-op-handover-algorithm.cc
+    model/pf-ff-mac-scheduler.cc
+    model/pss-ff-mac-scheduler.cc
+    model/rem-spectrum-phy.cc
+    model/rr-ff-mac-scheduler.cc
+    model/simple-ue-component-carrier-manager.cc
+    model/tdbet-ff-mac-scheduler.cc
+    model/tdmt-ff-mac-scheduler.cc
+    model/tdtbfq-ff-mac-scheduler.cc
+    model/tta-ff-mac-scheduler.cc
+)
+
+set(header_files
+    ${emu_headers}
+    helper/cc-helper.h
+    helper/epc-helper.h
+    helper/lte-global-pathloss-database.h
+    helper/lte-helper.h
+    helper/lte-hex-grid-enb-topology-helper.h
+    helper/lte-stats-calculator.h
+    helper/mac-stats-calculator.h
+    helper/no-backhaul-epc-helper.h
+    helper/phy-rx-stats-calculator.h
+    helper/phy-stats-calculator.h
+    helper/phy-tx-stats-calculator.h
+    helper/point-to-point-epc-helper.h
+    helper/radio-bearer-stats-calculator.h
+    helper/radio-bearer-stats-connector.h
+    helper/radio-environment-map-helper.h
+    model/a2-a4-rsrq-handover-algorithm.h
+    model/a3-rsrp-handover-algorithm.h
+    model/component-carrier-enb.h
+    model/component-carrier-ue.h
+    model/component-carrier.h
+    model/cqa-ff-mac-scheduler.h
+    model/epc-enb-application.h
+    model/epc-enb-s1-sap.h
+    model/epc-gtpc-header.h
+    model/epc-gtpu-header.h
+    model/epc-mme-application.h
+    model/epc-pgw-application.h
+    model/epc-s11-sap.h
+    model/epc-s1ap-sap.h
+    model/epc-sgw-application.h
+    model/epc-tft-classifier.h
+    model/epc-tft.h
+    model/epc-ue-nas.h
+    model/epc-x2-header.h
+    model/epc-x2-sap.h
+    model/epc-x2.h
+    model/eps-bearer-tag.h
+    model/eps-bearer.h
+    model/fdbet-ff-mac-scheduler.h
+    model/fdmt-ff-mac-scheduler.h
+    model/fdtbfq-ff-mac-scheduler.h
+    model/ff-mac-common.h
+    model/ff-mac-csched-sap.h
+    model/ff-mac-sched-sap.h
+    model/ff-mac-scheduler.h
+    model/lte-amc.h
+    model/lte-anr-sap.h
+    model/lte-anr.h
+    model/lte-as-sap.h
+    model/lte-asn1-header.h
+    model/lte-ccm-mac-sap.h
+    model/lte-ccm-rrc-sap.h
+    model/lte-chunk-processor.h
+    model/lte-common.h
+    model/lte-control-messages.h
+    model/lte-enb-cmac-sap.h
+    model/lte-enb-component-carrier-manager.h
+    model/lte-enb-cphy-sap.h
+    model/lte-enb-mac.h
+    model/lte-enb-net-device.h
+    model/lte-enb-phy-sap.h
+    model/lte-enb-phy.h
+    model/lte-enb-rrc.h
+    model/lte-ffr-algorithm.h
+    model/lte-ffr-distributed-algorithm.h
+    model/lte-ffr-enhanced-algorithm.h
+    model/lte-ffr-rrc-sap.h
+    model/lte-ffr-sap.h
+    model/lte-ffr-soft-algorithm.h
+    model/lte-fr-hard-algorithm.h
+    model/lte-fr-no-op-algorithm.h
+    model/lte-fr-soft-algorithm.h
+    model/lte-fr-strict-algorithm.h
+    model/lte-handover-algorithm.h
+    model/lte-handover-management-sap.h
+    model/lte-harq-phy.h
+    model/lte-interference.h
+    model/lte-mac-sap.h
+    model/lte-mi-error-model.h
+    model/lte-net-device.h
+    model/lte-pdcp-header.h
+    model/lte-pdcp-sap.h
+    model/lte-pdcp-tag.h
+    model/lte-pdcp.h
+    model/lte-phy-tag.h
+    model/lte-phy.h
+    model/lte-radio-bearer-info.h
+    model/lte-radio-bearer-tag.h
+    model/lte-rlc-am-header.h
+    model/lte-rlc-am.h
+    model/lte-rlc-header.h
+    model/lte-rlc-sap.h
+    model/lte-rlc-sdu-status-tag.h
+    model/lte-rlc-sequence-number.h
+    model/lte-rlc-tag.h
+    model/lte-rlc-tm.h
+    model/lte-rlc-um.h
+    model/lte-rlc.h
+    model/lte-rrc-header.h
+    model/lte-rrc-protocol-ideal.h
+    model/lte-rrc-protocol-real.h
+    model/lte-rrc-sap.h
+    model/lte-spectrum-phy.h
+    model/lte-spectrum-signal-parameters.h
+    model/lte-spectrum-value-helper.h
+    model/lte-ue-ccm-rrc-sap.h
+    model/lte-ue-cmac-sap.h
+    model/lte-ue-component-carrier-manager.h
+    model/lte-ue-cphy-sap.h
+    model/lte-ue-mac.h
+    model/lte-ue-net-device.h
+    model/lte-ue-phy-sap.h
+    model/lte-ue-phy.h
+    model/lte-ue-power-control.h
+    model/lte-ue-rrc.h
+    model/lte-vendor-specific-parameters.h
+    model/no-op-component-carrier-manager.h
+    model/no-op-handover-algorithm.h
+    model/pf-ff-mac-scheduler.h
+    model/pss-ff-mac-scheduler.h
+    model/rem-spectrum-phy.h
+    model/rr-ff-mac-scheduler.h
+    model/simple-ue-component-carrier-manager.h
+    model/tdbet-ff-mac-scheduler.h
+    model/tdmt-ff-mac-scheduler.h
+    model/tdtbfq-ff-mac-scheduler.h
+    model/tta-ff-mac-scheduler.h
+)
+
+set(test_sources
+    test/epc-test-gtpu.cc
+    test/epc-test-s1u-downlink.cc
+    test/epc-test-s1u-uplink.cc
+    test/lte-ffr-simple.cc
+    test/lte-simple-helper.cc
+    test/lte-simple-net-device.cc
+    test/lte-simple-spectrum-phy.cc
+    test/lte-test-aggregation-throughput-scale.cc
+    test/lte-test-carrier-aggregation-configuration.cc
+    test/lte-test-carrier-aggregation.cc
+    test/lte-test-cell-selection.cc
+    test/lte-test-cqa-ff-mac-scheduler.cc
+    test/lte-test-cqi-generation.cc
+    test/lte-test-deactivate-bearer.cc
+    test/lte-test-downlink-power-control.cc
+    test/lte-test-downlink-sinr.cc
+    test/lte-test-earfcn.cc
+    test/lte-test-entities.cc
+    test/lte-test-fdbet-ff-mac-scheduler.cc
+    test/lte-test-fdmt-ff-mac-scheduler.cc
+    test/lte-test-fdtbfq-ff-mac-scheduler.cc
+    test/lte-test-frequency-reuse.cc
+    test/lte-test-harq.cc
+    test/lte-test-interference-fr.cc
+    test/lte-test-interference.cc
+    test/lte-test-ipv6-routing.cc
+    test/lte-test-link-adaptation.cc
+    test/lte-test-mimo.cc
+    test/lte-test-pathloss-model.cc
+    test/lte-test-pf-ff-mac-scheduler.cc
+    test/lte-test-phy-error-model.cc
+    test/lte-test-primary-cell-change.cc
+    test/lte-test-pss-ff-mac-scheduler.cc
+    test/lte-test-radio-link-failure.cc
+    test/lte-test-rlc-am-e2e.cc
+    test/lte-test-rlc-am-transmitter.cc
+    test/lte-test-rlc-um-e2e.cc
+    test/lte-test-rlc-um-transmitter.cc
+    test/lte-test-rr-ff-mac-scheduler.cc
+    test/lte-test-secondary-cell-handover.cc
+    test/lte-test-secondary-cell-selection.cc
+    test/lte-test-spectrum-value-helper.cc
+    test/lte-test-tdbet-ff-mac-scheduler.cc
+    test/lte-test-tdmt-ff-mac-scheduler.cc
+    test/lte-test-tdtbfq-ff-mac-scheduler.cc
+    test/lte-test-tta-ff-mac-scheduler.cc
+    test/lte-test-ue-measurements.cc
+    test/lte-test-ue-phy.cc
+    test/lte-test-uplink-power-control.cc
+    test/lte-test-uplink-sinr.cc
+    test/test-asn1-encoding.cc
+    test/test-epc-tft-classifier.cc
+    test/test-lte-antenna.cc
+    test/test-lte-epc-e2e-data.cc
+    test/test-lte-handover-delay.cc
+    test/test-lte-handover-target.cc
+    test/test-lte-rlc-header.cc
+    test/test-lte-rrc.cc
+    test/test-lte-x2-handover-measures.cc
+    test/test-lte-x2-handover.cc
+)
+
+build_lib(
+  LIBNAME lte
+  SOURCE_FILES ${source_files}
+  HEADER_FILES ${header_files}
+  LIBRARIES_TO_LINK
+    ${emu_libraries}
+    ${libcore}
+    ${libnetwork}
+    ${libspectrum}
+    ${libstats}
+    ${libbuildings}
+    ${libvirtual-net-device}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libinternet}
+    ${libcsma}
+  TEST_SOURCES ${test_sources}
+  MODULE_ENABLED_FEATURES ${emu_features}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/doc/source/conf.py ns-3.36/src/lte/doc/source/conf.py
--- ns-3.35/src/lte/doc/source/conf.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/doc/source/conf.py	2022-04-30 18:23:57.894733700 -0700
@@ -25,7 +25,7 @@
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.pngmath']
+extensions = ['sphinx.ext.imgmath']
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/CMakeLists.txt ns-3.36/src/lte/examples/CMakeLists.txt
--- ns-3.35/src/lte/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/examples/CMakeLists.txt	2022-04-30 18:23:57.918733800 -0700
@@ -0,0 +1,45 @@
+set(base_examples
+    lena-cc-helper
+    lena-cqi-threshold
+    lena-deactivate-bearer
+    lena-distributed-ffr
+    lena-dual-stripe
+    lena-fading
+    lena-frequency-reuse
+    lena-intercell-interference
+    lena-ipv6-addr-conf
+    lena-ipv6-ue-rh
+    lena-ipv6-ue-ue
+    lena-pathloss-traces
+    lena-profiling
+    lena-radio-link-failure
+    lena-rem
+    lena-rem-sector-antenna
+    lena-rlc-traces
+    lena-simple
+    lena-simple-epc
+    lena-simple-epc-backhaul
+    lena-uplink-power-control
+    lena-x2-handover
+    lena-x2-handover-measures
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK ${liblte}
+  )
+endforeach()
+
+if(${ENABLE_EMU})
+  build_lib_example(
+    NAME lena-simple-epc-emu
+    SOURCE_FILES lena-simple-epc-emu.cc
+    LIBRARIES_TO_LINK ${liblte}
+                      ${fd-net-device}
+  )
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-cqi-threshold.cc ns-3.36/src/lte/examples/lena-cqi-threshold.cc
--- ns-3.35/src/lte/examples/lena-cqi-threshold.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-cqi-threshold.cc	2022-04-30 18:23:57.918733800 -0700
@@ -67,10 +67,10 @@
   cmd.Parse (argc, argv);
 	
   // to save a template default attribute file run it like this:
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText"
   //
   // to load a previously created default attribute file
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText"
 
   ConfigStore inputConfig;
   inputConfig.ConfigureDefaults ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-fading.cc ns-3.36/src/lte/examples/lena-fading.cc
--- ns-3.35/src/lte/examples/lena-fading.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-fading.cc	2022-04-30 18:23:57.922733800 -0700
@@ -37,10 +37,10 @@
   cmd.Parse (argc, argv);
 	
   // to save a template default attribute file run it like this:
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText"
   //
   // to load a previously created default attribute file
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText"
 
   //ConfigStore inputConfig;
   //inputConfig.ConfigureDefaults ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-radio-link-failure.cc ns-3.36/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.35/src/lte/examples/lena-radio-link-failure.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-radio-link-failure.cc	2022-04-30 18:23:57.922733800 -0700
@@ -266,7 +266,7 @@
  *
  * The example can be run as follows:
  *
- * ./waf --run "lena-radio-link-failure --numberOfEnbs=1 --simTime=25"
+ * ./ns3 run "lena-radio-link-failure --numberOfEnbs=1 --simTime=25"
  */
 int
 main (int argc, char *argv[])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-rem.cc ns-3.36/src/lte/examples/lena-rem.cc
--- ns-3.35/src/lte/examples/lena-rem.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-rem.cc	2022-04-30 18:23:57.922733800 -0700
@@ -37,10 +37,10 @@
   cmd.Parse (argc, argv);
 	
   // to save a template default attribute file run it like this:
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText"
   //
   // to load a previously created default attribute file
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-first-sim
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText"
 
   ConfigStore inputConfig;
   inputConfig.ConfigureDefaults ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-rem-sector-antenna.cc ns-3.36/src/lte/examples/lena-rem-sector-antenna.cc
--- ns-3.35/src/lte/examples/lena-rem-sector-antenna.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-rem-sector-antenna.cc	2022-04-30 18:23:57.922733800 -0700
@@ -37,7 +37,7 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   ConfigStore inputConfig;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-simple.cc ns-3.36/src/lte/examples/lena-simple.cc
--- ns-3.35/src/lte/examples/lena-simple.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-simple.cc	2022-04-30 18:23:57.922733800 -0700
@@ -39,10 +39,10 @@
   cmd.Parse (argc, argv);
 
   // to save a template default attribute file run it like this:
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-simple
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Save --ns3::ConfigStore::FileFormat=RawText"
   //
   // to load a previously created default attribute file
-  // ./waf --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText" --run src/lte/examples/lena-simple
+  // ./ns3 run src/lte/examples/lena-first-sim --command-template="%s --ns3::ConfigStore::Filename=input-defaults.txt --ns3::ConfigStore::Mode=Load --ns3::ConfigStore::FileFormat=RawText"
 
   ConfigStore inputConfig;
   inputConfig.ConfigureDefaults ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/examples/lena-simple-epc-backhaul.cc ns-3.36/src/lte/examples/lena-simple-epc-backhaul.cc
--- ns-3.35/src/lte/examples/lena-simple-epc-backhaul.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/examples/lena-simple-epc-backhaul.cc	2022-04-30 18:23:57.922733800 -0700
@@ -156,6 +156,7 @@
       for (uint16_t i = 0; i < numNodePairs; ++i)
         {
           Ptr<Node> enb = enbNodes.Get (i);
+          std::vector<uint16_t> cellIds (1, i);
 
           // Create a point to point link between the eNB and the SGW with
           // the corresponding new NetDevices on each side
@@ -175,7 +176,7 @@
           Ipv4Address enbS1uAddress = sgwEnbIpIfaces.GetAddress (1);
 
           // Create S1 interface between the SGW and the eNB
-          epcHelper->AddS1Interface (enb, enbS1uAddress, sgwS1uAddress);
+          epcHelper->AddS1Interface (enb, enbS1uAddress, sgwS1uAddress, cellIds);
         }
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/emu-epc-helper.cc ns-3.36/src/lte/helper/emu-epc-helper.cc
--- ns-3.35/src/lte/helper/emu-epc-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/emu-epc-helper.cc	2022-04-30 18:23:57.922733800 -0700
@@ -114,22 +114,21 @@
 
 
 void
-EmuEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId)
+EmuEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds)
 {
-  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellId);
+  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellIds.size ());
 
-  NoBackhaulEpcHelper::AddEnb (enb, lteEnbNetDevice, cellId);
+  NoBackhaulEpcHelper::AddEnb (enb, lteEnbNetDevice, cellIds);
 
   // Create an EmuFdNetDevice for the eNB to connect with the SGW and other eNBs
   EmuFdNetDeviceHelper emu;
-  NS_LOG_LOGIC ("eNB cellId: " << cellId);
+  NS_LOG_LOGIC ("eNB cellId: " << cellIds.at (0));
   NS_LOG_LOGIC ("eNB device: " << m_enbDeviceName);
   emu.SetDeviceName (m_enbDeviceName);
   NetDeviceContainer enbDevices = emu.Install (enb);
 
-  NS_ABORT_IF ((cellId == 0) || (cellId > 255));
   std::ostringstream enbMacAddress;
-  enbMacAddress << m_enbMacAddressBase << ":" << std::hex << std::setfill ('0') << std::setw (2) << cellId;
+  enbMacAddress << m_enbMacAddressBase << ":" << std::hex << std::setfill ('0') << std::setw (2) << cellIds.at (0);
   NS_LOG_LOGIC ("eNB MAC address: " << enbMacAddress.str ());
   Ptr<NetDevice> enbDev = enbDevices.Get (0);
   enbDev->SetAttribute ("Address", Mac48AddressValue (enbMacAddress.str ().c_str ()));
@@ -143,7 +142,7 @@
   Ipv4Address enbAddress = enbIpIfaces.GetAddress (0);
   Ipv4Address sgwAddress = m_sgwIpIfaces.GetAddress (0);
 
-  NoBackhaulEpcHelper::AddS1Interface (enb, enbAddress, sgwAddress, cellId);
+  NoBackhaulEpcHelper::AddS1Interface (enb, enbAddress, sgwAddress, cellIds);
 }
 
 
@@ -181,16 +180,18 @@
   // Add X2 interface to both eNBs' X2 entities
   Ptr<EpcX2> enb1X2 = enb1->GetObject<EpcX2> ();
   Ptr<LteEnbNetDevice> enb1LteDev = enb1->GetDevice (0)->GetObject<LteEnbNetDevice> ();
-  uint16_t enb1CellId = enb1LteDev->GetCellId ();
+  std::vector<uint16_t> enb1CellIds = enb1LteDev->GetCellIds ();
+  uint16_t enb1CellId = enb1CellIds.at (0);
   NS_LOG_LOGIC ("LteEnbNetDevice #1 = " << enb1LteDev << " - CellId = " << enb1CellId);
 
   Ptr<EpcX2> enb2X2 = enb2->GetObject<EpcX2> ();
   Ptr<LteEnbNetDevice> enb2LteDev = enb2->GetDevice (0)->GetObject<LteEnbNetDevice> ();
-  uint16_t enb2CellId = enb2LteDev->GetCellId ();
+  std::vector<uint16_t> enb2CellIds = enb2LteDev->GetCellIds ();
+  uint16_t enb2CellId = enb2CellIds.at (0);
   NS_LOG_LOGIC ("LteEnbNetDevice #2 = " << enb2LteDev << " - CellId = " << enb2CellId);
 
-  enb1X2->AddX2Interface (enb1CellId, enb1Addr, enb2CellId, enb2Addr);
-  enb2X2->AddX2Interface (enb2CellId, enb2Addr, enb1CellId, enb1Addr);
+  enb1X2->AddX2Interface (enb1CellId, enb1Addr, enb2CellIds, enb2Addr);
+  enb2X2->AddX2Interface (enb2CellId, enb2Addr, enb1CellIds, enb1Addr);
 
   enb1LteDev->GetRrc ()->AddX2Neighbour (enb2LteDev->GetCellId ());
   enb2LteDev->GetRrc ()->AddX2Neighbour (enb1LteDev->GetCellId ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/emu-epc-helper.h ns-3.36/src/lte/helper/emu-epc-helper.h
--- ns-3.35/src/lte/helper/emu-epc-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/emu-epc-helper.h	2022-04-30 18:23:57.922733800 -0700
@@ -61,7 +61,7 @@
   virtual void DoDispose ();
 
   // inherited from EpcHelper
-  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId);
+  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds);
   virtual void AddX2Interface (Ptr<Node> enbNode1, Ptr<Node> enbNode2);
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/epc-helper.h ns-3.36/src/lte/helper/epc-helper.h
--- ns-3.35/src/lte/helper/epc-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/epc-helper.h	2022-04-30 18:23:57.922733800 -0700
@@ -75,9 +75,9 @@
    * \param enbNode the previously created eNB node which is to be
    * added to the EPC
    * \param lteEnbNetDevice the LteEnbNetDevice of the eNB node
-   * \param cellId ID of the eNB
+   * \param cellIds IDs of cells served by this eNB
    */
-  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId) = 0;
+  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds) = 0;
 
   /** 
    * Notify the EPC of the existence of a new UE which might attach at a later time
@@ -101,9 +101,9 @@
    * \param enb eNB peer of the S1 interface
    * \param enbAddress eNB IPv4 address of the S1 interface
    * \param sgwAddress SGW IPv4 address of the S1 interface
-   * \param cellId cellId of the eNB
+   * \param cellIds cellIds of the eNB
    */
-  virtual void AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, uint16_t cellId = 0) = 0;
+  virtual void AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, std::vector<uint16_t> cellIds) = 0;
 
 
   /** 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/lte-helper.cc ns-3.36/src/lte/helper/lte-helper.cc
--- ns-3.35/src/lte/helper/lte-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/lte-helper.cc	2022-04-30 18:23:57.922733800 -0700
@@ -516,7 +516,6 @@
                    "CC map size (" << m_componentCarrierPhyParams.size () <<
                    ") must be equal to number of carriers (" <<
                    m_noOfCcs << ")");
-
   // create component carrier map for this eNb device
   std::map<uint8_t,Ptr<ComponentCarrierBaseStation> > ccMap;
   for (std::map<uint8_t, ComponentCarrier >::iterator it = m_componentCarrierPhyParams.begin ();
@@ -740,7 +739,7 @@
   if (m_epcHelper != 0)
     {
       NS_LOG_INFO ("adding this eNB to the EPC");
-      m_epcHelper->AddEnb (n, dev, dev->GetCellId ());
+      m_epcHelper->AddEnb (n, dev, dev->GetCellIds ());
       Ptr<EpcEnbApplication> enbApp = n->GetApplication (0)->GetObject<EpcEnbApplication> ();
       NS_ASSERT_MSG (enbApp != 0, "cannot retrieve EpcEnbApplication");
 
@@ -774,7 +773,6 @@
                    "CC map size (" << m_componentCarrierPhyParams.size () <<
                    ") must be equal to number of carriers (" <<
                    m_noOfCcs << ")");
-
   std::map<uint8_t, Ptr<ComponentCarrierUe> > ueCcMap;
 
   for (std::map< uint8_t, ComponentCarrier >::iterator it = m_componentCarrierPhyParams.begin();
@@ -1009,7 +1007,7 @@
 }
 
 void
-LteHelper::Attach (Ptr<NetDevice> ueDevice, Ptr<NetDevice> enbDevice)
+LteHelper::Attach (Ptr<NetDevice> ueDevice, Ptr<NetDevice> enbDevice, uint8_t componentCarrierId)
 {
   NS_LOG_FUNCTION (this);
   //enbRrc->SetCellId (enbDevice->GetObject<LteEnbNetDevice> ()->GetCellId ());
@@ -1018,7 +1016,8 @@
   Ptr<LteEnbNetDevice> enbLteDevice = enbDevice->GetObject<LteEnbNetDevice> ();
 
   Ptr<EpcUeNas> ueNas = ueLteDevice->GetNas ();
-  ueNas->Connect (enbLteDevice->GetCellId (), enbLteDevice->GetDlEarfcn ());
+  Ptr<ComponentCarrierEnb> componentCarrier = DynamicCast<ComponentCarrierEnb> (enbLteDevice->GetCcMap ().at (componentCarrierId));
+  ueNas->Connect (componentCarrier->GetCellId (), componentCarrier->GetDlEarfcn ());
 
   if (m_epcHelper != 0)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/lte-helper.h ns-3.36/src/lte/helper/lte-helper.h
--- ns-3.35/src/lte/helper/lte-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/lte-helper.h	2022-04-30 18:23:57.922733800 -0700
@@ -404,6 +404,7 @@
    * \brief Manual attachment of a UE device to the network via a given eNodeB.
    * \param ueDevice the UE device to be attached
    * \param enbDevice the destination eNodeB device
+   * \param componentCarrierId the destination eNodeB component carrier
    *
    * In addition, the function also instructs the UE to immediately enter
    * CONNECTED mode and activates the default EPS bearer.
@@ -412,7 +413,7 @@
    * Note that this function will disable Idle mode initial cell selection
    * procedure.
    */
-  void Attach (Ptr<NetDevice> ueDevice, Ptr<NetDevice> enbDevice);
+  void Attach (Ptr<NetDevice> ueDevice, Ptr<NetDevice> enbDevice, uint8_t componentCarrierId = 0);
 
   /** 
    * \brief Manual attachment of a set of UE devices to the network via the
